/**
 * Created by Mai on 2017/7/25.
 */
let MainTreeCol = {
    getText: {
        subType: function (node) {
            if (node.sourceType === projectObj.project.Bills.getSourceType()) {
                return billText[node.data.type];
                // CSL, 2017-11-29
            } else if (node.sourceType === projectObj.project.Ration.getSourceType()) {
                if (node.data.type == 1 || node.data.type == undefined)    // 兼容旧定额
                    return '定';
                else if (node.data.type == 2) {    // 量价
                    return volumePriceMaps[node.data.subType];
                }
                else if (node.data.type == 3) {    // 工料机定额
                    return projectObj.project.projectGLJ.getShortNameByID(node.data.subType);//工料机名字缩写
                }else if(node.data.type == 4){//安装增加费生成的定额
                    return '安';
                }
            } else if (node.sourceType === projectObj.project.ration_glj.getSourceType()) {
                return projectObj.project.projectGLJ.getShortNameByID(node.data.subType);//工料机名字缩写
            }
        },
        quantity:function (node) {
          if(node.sourceType === projectObj.project.ration_glj.getSourceType()){
              return gljOprObj.getTotalQuantity(node.data);
          }else {
              return calcTools.uiNodeQty(node)?calcTools.uiNodeQty(node):null;
          }
        },
        // CSL, 2017-11-28
        calcProgramName: function (node) {
            let programID = node.data.programID;
            if (!programID) return
            else return projectObj.project.calcProgram.compiledTemplateMaps[programID];
        },
        calcBase: function (node) {
            if (node.data.calcBase && node.data.calcBase != ""){
                return cbParser.toFExpr(node.data.calcBase);
            }
        },
        code: function (node) {
            if(!isDef(node)){
                return '';
            }
            let rst = '';
            if(node.sourceType === projectObj.project.Ration.getSourceType() && node.data.type === rationType.ration
                && isDef(node.data.code) && isDef(node.data.prefix) && node.data.prefix !== ''){
                rst = node.data.prefix + node.data.code.replace(new RegExp(node.data.prefix, 'g'), '');
            }
            else
                rst = isDef(node.data.code) ? node.data.code : '';

            if (node.data.adjustState && rst != '')
                rst = rst + rationPrefix.replace;
            return rst;
        },
        marketPrice:function (node) {
            if((node.sourceType === projectObj.project.Ration.getSourceType()&&node.data.type!=rationType.ration)||node.sourceType==projectObj.project.ration_glj.getSourceType()){
                if(node.data.marketUnitFee)  return calcTools.uiGLJPrice(node.data.marketUnitFee);
            }
        },
        feeRate:function (node) {
            if(node.data.feeRateID){
                let rate = projectObj.project.FeeRate.getFeeRateByID(node.data.feeRateID);
                if (rate) return rate.rate;
            }
            return node.data.feeRate;
        },
        maxPrice:function (node) {
            if(node.data.outPutMaxPrice == true || node.data.outPutLimitPrice == true){
                if(node.data.maxPrice === null&&node.data.feesIndex &&node.data.feesIndex.common) {
                    return node.data.feesIndex.common.unitFee?node.data.feesIndex.common.unitFee:""
                };
                return node.data.maxPrice?node.data.maxPrice:"";
            }
            return "";
        },
        minPrice:function (node) {
            if(node.data.outPutLimitPrice == true){
                if(node.data.minPrice === null&&node.data.feesIndex &&node.data.feesIndex.common) return node.data.feesIndex.common.unitFee?node.data.feesIndex.common.unitFee:"";
                return node.data.minPrice?node.data.minPrice:"";
            }
            return "";
        },
    },
    readOnly: {
        // Vincent, 2018-01-09
        subType: function (node) {
            if (calcTools.isVolumePrice(node)) return false;

            if(MainTreeCol.readOnly.bills(node)){
                return true;
            }
            if(MainTreeCol.readOnly.ration(node)){
                return true;
            }
            if(MainTreeCol.readOnly.non_editSubType(node)){
                return true;
            }else if(gljOprObj.hasComposition(node.data,node.sourceType === ModuleNames.ration)){
                return true;
            }
            return false;
        },
        calcProgramName: function (node) {
            if (node.sourceType === projectObj.project.Ration.getSourceType() ||
                (calcTools.isLeafBill(node) && projectObj.project.property.billsCalcMode === leafBillGetFeeType.billsPrice)
            ) {
                //当打勾估价项目选项后，该定额取费专业只读
                if(node.data.evaluationProject == 1){
                    return true;
                }
                return false;
            }
            return true;
        },
        non_editSubType: function (node) {
            return node.data.subType != 201 && node.data.subType != 4 && node.data.subType != 5
        },
        commonUnitFee: function (node) {
            // 2018-11-15 zhang
            let Bills =projectObj.project.Bills;
            if(node.sourceType == ModuleNames.bills){//针对清单、分项部分
                // 属于标题清单，只读
                if (calcTools.isTitleBills(node)) {
                    return true;
                }
                // 当前属于不可通过自身数据计算合价的部分，单价只读
                if (Bills.cantCalcToTalFeeByOwn(node)) {
                    return true;
                }
                // 不属于分部分项、施工技术措施项目的部分，如果不是叶子清单，或有基数计算/定额/量价/人材机 只读
                if(!calcTools.isLeafBill(node)||calcTools.isCalcBaseBill(node)||node.children.length > 0)return true;
            }
            //当前是定额，综合单价只读。 2018-11-15
            if(MainTreeCol.readOnly.ration(node)) return true;
            return false;
        },
        commonTotalFee: function (node) {
            // 属于标题清单，只读
            if (node.sourceType == ModuleNames.bills &&
                calcTools.isTitleBills(node)) {
                return true;
            }
            // 09-29 zhang
            let Bills =projectObj.project.Bills;
            // 当前属于不可通过自身数据计算合价的部分，合价只读
            if (Bills.cantCalcToTalFeeByOwn(node)) {
                return true;
            }
            // 不属于分部分项、施工技术措施项目的部分，如果不是叶子清单，或有基数计算/定额/量价/人材机 只读
            if(!calcTools.isLeafBill(node)||calcTools.isCalcBaseBill(node)||node.children.length > 0){
                return true;
            }
            return false;
        },
        //根据节点、父节点类型判断是否可用计算基数
        calcBaseType: function (node) {
            function isFlag(v) {
                return this.isDef(v.flagsIndex) && this.isDef(v.flagsIndex.fixed);
            }
            // 如果清单为超高子目指定清单，则只读
            if (node.data.ID === projectObj.project.projectInfo.property.overHeightSpecificID) {
                return true;
            }
            let calcBase = projectObj.project.calcBase;
            let parent = node.parent;
            if (isFlag(node.data) && (node.data.flagsIndex.fixed.flag === calcBase.fixedFlag.SUB_ENGINERRING
                || node.data.flagsIndex.fixed.flag === calcBase.fixedFlag.CONSTRUCTION_TECH)) {
                return true;
            } else if (isFlag(node.data) && node.data.flagsIndex.fixed.flag === calcBase.fixedFlag.CONSTRUCTION_ORGANIZATION) {
                return false;
            } else {
                if (!parent) {
                    return false;
                } else {
                    return this.calcBaseType(parent);
                }
            }
        },
        bills: function (node) {
            return node.sourceType === projectObj.project.Bills.getSourceType();
        },
        ration: function (node) {
            return calcTools.isRationItem(node);
        },
        isSubcontract: function (node) {
            return !calcTools.isRationCategory(node);
        },
        glj: function (node) {
            return node.sourceType == projectObj.project.ration_glj.getSourceType();
        },
        volumePrice: function (node) {
            return (node.data.type == rationType.volumePrice || node.data.type == rationType.gljRation);
        },
        non_bills: function (node) {
            return node.sourceType !== projectObj.project.Bills.getSourceType();
        },
        non_ration: function (node) {
            return node.sourceType !== projectObj.project.Ration.getSourceType();
        },
        non_volumePrice: function (node) {
            return !(node.data.type == rationType.volumePrice || node.data.type == rationType.gljRation);
        },
        billsParent: function (node) {
            return node.sourceType === projectObj.project.Bills.getSourceType() && node.source.children.length > 0;
        },
        leafBillsWithDetail: function (node) {
            return (!MainTreeCol.readOnly.billsParent(node)) && (node.children.length > 0);
        },
        forCalcBase: function (node) {
            // 属于标题清单，只读
            if (node.sourceType == ModuleNames.bills &&
                calcTools.isTitleBills(node)) {
                return true;
            }
            // to do according to billsParentType
            return MainTreeCol.readOnly.billsParent(node) || MainTreeCol.readOnly.non_bills(node) || MainTreeCol.readOnly.leafBillsWithDetail(node) || MainTreeCol.readOnly.calcBaseType(node);
        },
        forUnitFee: function (node) {
            return MainTreeCol.readOnly.ration(node) || MainTreeCol.readOnly.billsParent(node) || MainTreeCol.readOnly.leafBillsWithDetail(node);
        },
        forTotalFee: function (node) {
            return MainTreeCol.readOnly.non_bills(node) || MainTreeCol.readOnly.billsParent(node) || (MainTreeCol.readOnly.leafBillsWithDetail(node));
        },
        forQuantifyDetail: function (node) {
            return !(node.sourceType == ModuleNames.ration || !MainTreeCol.readOnly.billsParent(node));
        },
        forFeeRate: function (node) {
            let readOnly = true;
            // 属于标题清单，只读
            if (node.sourceType == ModuleNames.bills &&
                calcTools.isTitleBills(node)) {
                return true;
            }
            let Bills = projectObj.project.Bills;
            //只有当选中节点是清单，并且不属于“分部分项工程”或“技术措施项目”，并且是叶子清单且没有定额/量价/工料机时，费率列才可编辑
            if(MainTreeCol.readOnly.bills(node)){
                if(!Bills.isFBFX(node)&&!Bills.isTechMeasure(node)&&node.children.length<=0){//不属于“分部分项工程”或“技术措施项目”，并且是叶子清单且没有定额/量价/工料机
                    readOnly = false;
                }
            }
            return readOnly;
        },
        forQuantity: function (node) {
            if(node.sourceType === projectObj.project.Bills.getSourceType()){
                // 属于标题清单，只读
                if (calcTools.isTitleBills(node)) {
                    return true;
                }
                if(node.data.type==billType.DXFY||node.data.type==billType.FB||(node.data.type==billType.BILL&&MainTreeCol.readOnly.billsParent(node))){//大项费用、分部、清单父项行，工程量只读。
                    return true;
                }
            }else if(MainTreeCol.readOnly.glj(node) || OVER_HEIGHT.isOverHeight(node)){
                return true;
            }
            return false;
        },
        forMarketPrice: function (node) {
            return MainTreeCol.readOnly.bills(node) ||
                (node.sourceType === ModuleNames.ration && node.data.type == rationType.ration) ||
                gljOprObj.marketPriceReadOnly(node);
        },
        forContain:function (node) {
            return MainTreeCol.readOnly.non_ration(node)&&!MainTreeCol.readOnly.glj(node);
        },
        forCode:function (node) {
            let Bills = projectObj.project.Bills;
            if(MainTreeCol.readOnly.glj(node)|| (node.sourceType === projectObj.project.Ration.getSourceType()&&node.data.type===rationType.gljRation)){//是主材或者设备、或者是工料机类型的定额
                return true;
            }
            
            //2020-11-30 为了多行复制时，遇到只读的大项费，spreadjs 粘贴事件能触发，放开这里的只读限制
           /*  if(Bills.isTopThreeNode(node)){//是大项1、2、3项的编号设置为只读
                return true;
            } */
            return false;
        },
        forName:function (node) {
            // 属于标题清单，只读
            /* 2020-11-30 为了多行复制时，遇到只读的大项费，spreadjs 粘贴事件能触发，放开这里的只读限制
            if (node.sourceType == ModuleNames.bills &&
                calcTools.isTitleBills(node)) {
                return true;
            }
             */
            /*  2020-11-30 为了多行复制时，遇到只读的大项费，spreadjs 粘贴事件能触发，放开这里的只读限制
              if(projectObj.project.Bills.isTopThreeNode(node)){//是大项1、2、3项的编号设置为只读
                return true;
            } */
            return false;
        },
        forUnit:function (node) {
            if(MainTreeCol.readOnly.bills(node)&&(node.data.type==billType.DXFY||node.data.type==billType.FB)){//在大项费用、分部行，计量单位只读。
                return true;
            }else {
               return calcTools.isRationItem(node);
            }
        },
        forContentCharacter: function (node, field) {
            // 定额工作内容下拉
            if (_compilationConfig.dynamicRationWorkContent &&
                node.sourceType === projectObj.project.Ration.getSourceType() &&
                field === 'jobContentText') {
                return false;
            }
            return !MainTreeCol.readOnly.bills(node) || (node.data.type !== billType.BILL && node.data.type !== billType.FX && node.data.type !== billType.BX);
        },
        forRuleText: function (node) {
            if(MainTreeCol.readOnly.bills(node)){
                if(node.data.type === billType.FX || (node.data.type === billType.BILL && node.source.children.length === 0)){
                    return false;
                }
            }
            return true;
        },
        maxPrice:function (node) {
            // 对于投标项目只读
            /* if(+$('#fileKind').val() === _fileKind.tender) {
                return true;
            } */
            const hasOutPutMaxPriceCol = !!projectObj.project.projSetting.main_tree_col.cols.find(item => item.data.field === 'outPutMaxPrice');
            const hasOutPutLitmitPriceCol = !!projectObj.project.projSetting.main_tree_col.cols.find(item => item.data.field === 'outPutLitmitPrice');
            return projectObj.project.projectInfo.importedByInterface || (hasOutPutMaxPriceCol && (node.data.outPutMaxPrice === undefined || node.data.outPutMaxPrice === false)) || (hasOutPutLitmitPriceCol && (node.data.outPutLimitPrice === undefined || node.data.outPutLimitPrice === false));
        },
        minPrice: function (node) {
            const hasOutPutLitmitPriceCol = !!projectObj.project.projSetting.main_tree_col.cols.find(item => item.data.field === 'outPutLitmitPrice');
            return projectObj.project.projectInfo.importedByInterface || (hasOutPutLitmitPriceCol && (node.data.outPutLimitPrice === undefined || node.data.outPutLimitPrice === false));
        },
        // 超高降效
        forOverHeight: function (node) {
            const isOverHeight = OVER_HEIGHT.isOverHeight(node);
            const notFBFXAndMeasure = !projectObj.project.Bills.isFBFX(node)
                && !projectObj.project.Bills.isMeasure(node);
            const hasCalcBase = !!node.data.calcBase;    
            return isOverHeight || notFBFXAndMeasure || hasCalcBase;
        }
    },
    cellType: {
        unit: function (node,setting) {
            let tips = "";
            //在这里做要不要显示的判断
             if(node.sourceType == ModuleNames.bills){//清单悬浮提示
                //显示工程量计算规则
                if(node.data.ruleText){
                    tips += `<label class="font_blue">工程量计算规则：<br>${node.data.ruleText.replace(/\n/g,"<br>")}</label>`; 
                }
                if(projectObj.ifItemCharHiden(setting)){//项目特征列隐藏的时候
                    tips += node.data.itemCharacterText?`<br>${node.data.itemCharacterText}`:'';
                } 
             }
            if(node.sourceType == ModuleNames.ration && node.data.type == rationType.ration){//定额类型时，显示人材机，工作内容等
                //这里的人材机需要进行过滤，在初始化时组装会影响性能，应实时显示
                tips = MainTreeCol.getRationUnitTips
            }
             let dynamicCombo = sheetCommonObj.getTipsCombo(true,tips,setting,node);//sheetCommonObj.getDynamicCombo(true);
            dynamicCombo.itemHeight(10).items(['m', 'm2', 'm3', 'km', 't', 'kg', '台班', '工日', '昼夜', '元', '项', '处', '个', '件',
                '根', '组', '系统', '台', '套', '株', '丛', '缸', '支', '只', '块', '座', '对', '份', '樘', '攒', '榀']).editable(true);
            return dynamicCombo;
        },
        units: function () {
            this.unit;
        },
        jobContent: function (node) {
            // 定额工作内容下拉
            if (_compilationConfig.dynamicRationWorkContent &&
                node.sourceType === projectObj.project.Ration.getSourceType()) {
                let combo = sheetCommonObj.getDynamicCombo();
                combo._maxDropDownItems = 10;
                combo.items(contentOprObj.getContentTexts(node.parent));
                return combo;
            }
        },
        feeRate: function () {
            return feeRateObject.getFeeRateEditCellType();
        },
        quantity:function (node) {
            if(!MainTreeCol.readOnly.forQuantity(node)){
              return  quantityEditObj.getQuantityEditCellType();
            }
        },
        calcBase: function (node) {
            let readOnly = projectReadOnly || !calcBaseView.ifEdit('bills', projectObj.project.mainTree.items.indexOf(node));
            return sheetCommonObj.getCusButtonCellType(calcBaseView.onCalcBaseButtonClick,readOnly)
        },

        // CSL, 2017-11-28
        calcProgramName: function (node) {
            if (
                node.sourceType === projectObj.project.Ration.getSourceType() ||
                (calcTools.isLeafBill(node) && projectObj.project.property.billsCalcMode === leafBillGetFeeType.billsPrice)
            ) {
                // var names = new GC.Spread.Sheets.CellTypes.ComboBox();
                var names = sheetCommonObj.getDynamicCombo();
                names._maxDropDownItems = 10;
                names.items(projectObj.project.calcProgram.compiledTemplateNames);
                return names;
            }
        },

        // Vincent, 2018-01-09
        subType: function (node) {
            if(node.sourceType!=projectObj.project.Bills.getSourceType()){
                let VPType = sheetCommonObj.getDynamicCombo();
                if(node.sourceType == projectObj.project.Ration.getSourceType()){//是定额类型
                    if(node.data.type == rationType.volumePrice){
                        VPType.itemHeight(5).items(["人工", "材料", "机械", "主材", "设备"])
                        return VPType;
                    }else if(node.data.type == rationType.gljRation){
                        if(!MainTreeCol.readOnly.non_editSubType(node)&&gljOprObj.hasComposition(node.data,true)==false){
                            VPType.itemHeight(3).items(["材料", "主材", "设备"]);
                            return VPType;
                        }
                    }
                }else if(node.sourceType === projectObj.project.ration_glj.getSourceType()){//是工料机类型
                    if(!MainTreeCol.readOnly.non_editSubType(node)&&gljOprObj.hasComposition(node.data)==false){
                        VPType.itemHeight(3).items(["材料", "主材", "设备"]);
                        return VPType;
                    }
                }
            }
        },
        isSubcontract: function (node){
            if (calcTools.isRationCategory(node))
                return new GC.Spread.Sheets.CellTypes.CheckBox();
        },
        isEstimate:function (node) {
            //只对分项、补项、材料(包括混凝土等)、主材、设备有效
            if(MainTreeCol.readOnly.glj(node)||(calcTools.isGljRation(node)&&projectObj.project.projectGLJ.isEstimateType(node.data.subType))||(MainTreeCol.readOnly.bills(node)&&(node.data.type == billType.BX||node.data.type == billType.FX))){
                return new GC.Spread.Sheets.CellTypes.CheckBox();
            }
        },
        evaluationProject:function (node) {
            if(node.sourceType == ModuleNames.ration){
                return new GC.Spread.Sheets.CellTypes.CheckBox();
            }

        },
        commonTotalFee: function (node) {
            let readOnly = projectReadOnly || !calcBaseView.ifEdit('bills', projectObj.project.mainTree.items.indexOf(node));
            return sheetCommonObj.getCusButtonCellType(projectObj.onCommonTotalFeeButtonClick,readOnly) //projectObj.getCommonTotalFeeCellType();
        },
        mainBills:function (node) {
            if(MainTreeCol.mainBillsEnable(node)) {
                return projectObj.project.projectInfo.property.lockBills 
                    ? sheetCommonObj.getReadOnlyCheckBox()
                    : sheetCommonObj.getCheckBox(true)
            };
      },
      lockUnitPrice: function (node) {
          //仅未使用基数计算的清单有效
          if(node.sourceType == ModuleNames.bills && !(node.data.calcBase&&node.data.calcBase!="")) return sheetCommonObj.getCheckBox();
      },
        mainNodeCheckBox:function (node,setting,field) {//分部分项、措施项目下的清单、定额
            let Bills = projectObj.project.Bills;
            if((Bills.isFBFX(node)||Bills.isMeasure(node)) && node.sourceType != ModuleNames.ration_glj){
                //有基数计算时或超高子目,面积增加费不可勾选
                if(field == 'areaIncreaseFee' && node.data.calcBase && node.data.calcBase!="" || itemIncreaseFeeObj.isItemIncrease(node)) return;
                return sheetCommonObj.getCheckBox(false);
            }

        },
        outPutMaxPrice:function (node) {
            if(MainTreeCol.mainBillsEnable(node)) {
                return projectObj.project.projectInfo.importedByInterface || projectObj.project.projectInfo.property.lockBills
                    ? sheetCommonObj.getReadOnlyCheckBox()
                    : sheetCommonObj.getCheckBox();
            }
        },
        outPutLimitPrice:function (node) {
            if(MainTreeCol.mainBillsEnable(node)) {
                return projectObj.project.projectInfo.importedByInterface || projectObj.project.projectInfo.property.lockBills
                ? sheetCommonObj.getReadOnlyCheckBox()
                : sheetCommonObj.getCheckBox();
            }
        },
        overHeight: function (node) {
            const isOverHeight = OVER_HEIGHT.isOverHeight(node);
            const notFBFXAndMeasure = !projectObj.project.Bills.isFBFX(node)
                && !projectObj.project.Bills.isMeasure(node);
            const hasCalcBase = node.data.calcBase;
            if (isOverHeight || notFBFXAndMeasure || hasCalcBase) {
                return;
            }
            const dynamicCombo = sheetCommonObj.getDynamicCombo();
            const items = OVER_HEIGHT.getComboData();
            dynamicCombo._maxDropDownItems = 10;
            dynamicCombo.items(items);
            return dynamicCombo;
        },
        /* maxPrice: function (node, setting) {
            const tips = () => {
                const maxPriceRate = projectObj.project.property.maxPriceRate || 0;
                return node.data.maxPrice ? `最高限价=清单综合单价*（1+${maxPriceRate}%）` : '';
            };
            return sheetCommonObj.getTipsText(tips, setting, node);
        },
        minPrice: function (node, setting) {
            const tips = () => {
                const minPriceRate = projectObj.project.property.minPriceRate || 0;
                return  node.data.minPrice ? `最低限价=清单综合单价*（1-${minPriceRate}%）` : '';
            };
            return sheetCommonObj.getTipsText(tips, setting, node);
        } */
    },
    mainBillsEnable:function (node) {
        let Bills = projectObj.project.Bills;
        //仅“分部分项工程”或“施工技术措施项目”下的分部、分项、补项、清单可编辑
        return ((Bills.isFBFX(node)||Bills.isTechMeasure(node))&&node.sourceType == ModuleNames.bills)
    },
    editChecking:function(node,field){
        if(node.sourceType==projectObj.project.Bills.getSourceType()){
            return MainTreeCol.lockBillChecking(node,field)
        }
        if(gljOprObj.isInstallationNode(node) || OVER_HEIGHT.isOverHeight(node)){//如果是通过安装增加费、超高降效自动生成的，都是只读类型
            return true;
        }
        return false;
    },
    lockBillChecking:function (node,field) {//true就是不可编辑，被锁定
        if(projectObj.project.isBillsLocked()&&projectObj.project.withinBillsLocked(node)){
            return (field == "feesIndex.common.unitFee"||field=="feesIndex.common.totalFee"||field=="calcBase"||field=="feeRate")?false:true;// 锁定状态下，除了综合单价、综合合价、计算基数、费率这个几，其它的都不能编辑
        }
        return false
    },
    setAutoHeight:function (cell,node) {//设置自动行高
        cell.wordWrap(MainTreeCol.needAutoFit(node));
    },
    setAutoFitRow:function (sheet,node) {
        if(MainTreeCol.needAutoFit(node)){
            sheet.autoFitRow(node.serialNo());
        }
    },
    needAutoFit:function (node) {
        let displaySetting = projectObj.project.property.displaySetting;
        let billsAutoH = displaySetting && displaySetting.billsAutoHeight?displaySetting.billsAutoHeight:false;
        let rationAutoH = displaySetting && displaySetting.rationAutoHeight?displaySetting.rationAutoHeight:false;
        if(node.sourceType === projectObj.project.Bills.getSourceType()&&billsAutoH == true){
            return true;
        }
        if(node.sourceType !== projectObj.project.Bills.getSourceType()&& rationAutoH == true){
            return true;
        }
        return false;
    },
    getEvent: function (eventName) {
        let names = eventName.split('.');
        let event = this;
        for (let name of names) {
            if (event[name]) {
                event = event[name];
            } else {
                return null;
            }
        }
        if (event && Object.prototype.toString.apply(event) !== "[object Function]") {
            return null;
        } else {
            return event;
        }
    },
    getNumberFormatter: function (digit, align) {    // CSL, 2017-11-30 扩展：小数点是否对齐。
        if (align) {
            switch (digit) {
                case 1:
                    return '0.0';
                case 2:
                    return '0.00';
                case 3:
                    return '0.000';
                case 4:
                    return '0.0000';
                case 5:
                    return '0.00000';
                case 6:
                    return '0.000000';
                default:
                    return '0';
            }
            ;
        }
        else {
            switch (digit) {
                case 1:
                    return '0.#';
                case 2:
                    return '0.##';
                case 3:
                    return '0.###';
                case 4:
                    return '0.####';
                case 5:
                    return '0.#####';
                case 6:
                    return '0.######';
                default:
                    return '0';
            };
        }
    },
    getRationUnitTips:function (node) {
        let tips="";
        let ration_glj = projectObj.project.ration_glj;
        let gljList = gljOprObj.filterGljByRation(node.data, ration_glj.datas);
        gljList = gljUtil.sortRationGLJ(gljList);
        if(node.data.content && node.data.content.toString().trim() !== ''){
            tips += `<label class="nomargin font_blue">工作内容:<br>`;
            tips += `${node.data.content.replace(/\n/g,"<br>")}</label><br><br>`;
        }
        for(let glj of gljList){
            tips += `<label class="nomargin ${glj.type==gljType.MAIN_MATERIAL?"font_blue":""}">${glj.code} ${glj.name}${glj.specs ? '&nbsp;&nbsp;&nbsp;' + glj.specs : ''}&nbsp;&nbsp&nbsp;${glj.unit}&nbsp;&nbsp;&nbsp;${glj.quantity}</label><br>`;
        }
        if(node.data.annotation && node.data.annotation.toString().trim() !== ''){
            tips +='<br>';
            tips += `附注:<br>`;
            tips += `${node.data.annotation.replace(/\n/g,"<br>")}<br>`;
        }
        return tips
    },
    // 字体颜色w
    foreColor: {
        // 清单综合单价＞最高限价 清单综合单价<最低限价 时，标红显示
        'feesIndex.common.unitFee': function (node) {
            const color = 'red';
            return calcTools.unitFeeGTMaxPrice(node, 'common.unitFee') || calcTools.unitFeeLTMinPrice(node, 'common.unitFee') ? color : null;
        }
    },
    setNameCusButton:function(cell,node){
        let isFBNode = node.sourceType == ModuleNames.bills&&node.data.type == billType.FB;
        if(isFBNode){
           let CELL =sheetCommonObj.getCusButtonCellType(()=>{
            $("#selectFBFor").val("replace");   
            $('#selectFBDiv').modal('show');
            })
            cell.cellType(CELL); 
        }
    }
};

let colSettingObj = {
    settingSpread: null,
    checkBox: new GC.Spread.Sheets.CellTypes.CheckBox(),
    loadSetting: function (sheet, setting) {
        sheet.suspendPaint();
        sheet.suspendEvent();
        sheet.setRowCount(setting.cols.length);
        sheet.setColumnCount(setting.headRows, GC.Spread.Sheets.SheetArea.rowHeader);
        sheet.setColumnCount(1);
        sheet.getRange(-1, 0, -1, 1).cellType(this.checkBox).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
        sheet.getCell(0, 0, GC.Spread.Sheets.SheetArea.colHeader).value('显示');
        sheet.setColumnWidth(0, 100);
        sheet.setColumnWidth(0, 240, GC.Spread.Sheets.SheetArea.rowHeader);

        setting.cols.forEach(function (col, index) {
            let i, iCol = 0, cell;
            for (i = 0; i < col.head.spanCols.length; i++) {
                if (col.head.spanCols[i] !== 0) {
                    cell = sheet.getCell(index, iCol, GC.Spread.Sheets.SheetArea.rowHeader);
                    cell.value(col.head.titleNames[i]).hAlign(col.head.hAlign[i]).vAlign(col.head.vAlign[i]);
                    //cell.value(col.head.titleNames[i]).font(col.head.font).hAlign(col.head.hAlign[i]).vAlign(col.head.vAlign[i]);
                }
                if (col.head.spanCols[i] > 1 || col.head.spanRows[i] > 1) {
                    sheet.addSpan(index, iCol, col.head.spanRows[i], col.head.spanCols[i], GC.Spread.Sheets.SheetArea.rowHeader);
                }
                iCol += col.head.spanRows[i];
            };
            let colWidth = sheet.getColumnWidth(index, GC.Spread.Sheets.SheetArea.rowHeader);
            colWidth = colWidth > col.width ? colWidth : col.width;
            //sheet.setColumnWidth(index, colWidth, GC.Spread.Sheets.SheetArea.rowHeader);
            cell = sheet.getCell(index, 0).value(col.visible);
            sheet.autoFitRow(index);
        });
        sheet.resumeEvent();
        sheet.resumePaint();
    },
    initSettingSpread: function () {
        this.settingSpread = SheetDataHelper.createNewSpread($('#col_setting_spread')[0], {sheetCount: 1});
        sheetCommonObj.spreadDefaultStyle(this.settingSpread);
        this.settingSpread.options.showScrollTip = GC.Spread.Sheets.ShowScrollTip.vertical;
        this.settingSpread.bind(GC.Spread.Sheets.Events.ButtonClicked, function (sender, args) {
            if(args.sheet.isEditing()){
                args.sheet.endEdit(true);
            }
        });
        this.loadSetting(this.settingSpread.getActiveSheet(), projectObj.project.projSetting.main_tree_col);
    },
    dataChanged: function () {
        let sheet = this.settingSpread.getActiveSheet();
        for(let row = 0; row < sheet.getRowCount(); row++){
            let orgData = projectObj.project.projSetting.main_tree_col.cols[row].visible;
            let newData = sheet.getValue(row, 0);
            if(orgData != newData){
                return true;
            }
        }
        return false;
    },
    updateColSetting: function (skipSetValue = false,init=false) {
        let mainSheet = projectObj.mainSpread.getActiveSheet();
        if(!skipSetValue){
            let sheet = this.settingSpread.getActiveSheet();
            for (let iRow = 0; iRow < sheet.getRowCount(); iRow++) {
                projectObj.project.projSetting.main_tree_col.cols[iRow].visible = sheet.getValue(iRow, 0);
                projectObj.project.projSetting.mainGridSetting.cols[iRow].visible = sheet.getValue(iRow, 0);
            }
        }
        SheetDataHelper.massOperationSheet(mainSheet, function () {
            SheetDataHelper.refreshColumnVisible(projectObj.project.projSetting.mainGridSetting, mainSheet);
            //左右滚动条到最左边
            mainSheet.showColumn(projectObj.project.projSetting.mainGridSetting.frozenCols, GC.Spread.Sheets.HorizontalPosition.left);
        });
        //refresh nodes to autoFitRow
       if(init===false) projectObj.mainController.refreshTreeNode(projectObj.project.mainTree.roots, true);
        if(!skipSetValue){
            //列设置将项目特征和工作内容都取消打钩后，更新快速列设置
            if(!this.getVisible('itemCharacterText')){
                switchTznrHtml(true);
            }
            if(this.getVisible('itemCharacterText')){
                switchTznrHtml(false);
            }
        }
        //别人分享过来的项目，打开时，“显示特征”按钮应有效，不影响数据的修改
        if(!projectReadOnly){
            projectObj.project.pushNow('editColSetting', projectObj.project.projSetting.moduleName, {
                projectID: projectObj.project.ID(),
                main_tree_col: projectObj.project.projSetting.main_tree_col
            });
        }
    },
    setVisible: function (field, visible) {
        let mainTreeCols = projectObj.project.projSetting.main_tree_col.cols;
        for(let colSetting of mainTreeCols){
            if(colSetting.data.field === field){
                colSetting.visible = visible;
                break;
            }
        }
        let mainGridCols = projectObj.project.projSetting.mainGridSetting.cols;
        for(let colSetting of mainGridCols){
            if(colSetting.data.field === field){
                colSetting.visible = visible;
                break;
            }
        }
    },
    getVisible: function(field){
        let cols = projectObj.project.projSetting.main_tree_col.cols;
        for(let colSetting of cols){
            if(colSetting.data.field === field){
                return colSetting.visible;
            }
        }
        return false;
    },
    getColByField: function (field) {
        let cols = projectObj.project.projSetting.main_tree_col.cols;
        for(let i = 0; i < cols.length; i++){
            let colSetting = cols[i];
            if(colSetting.data.field === field){
                
                return i;
            }
        }
        return null;
    },
    getFieldByCol: function (col) {
        let cols = projectObj.project.projSetting.main_tree_col.cols;
        let colSetting = cols[col];
        return colSetting ? colSetting.data.field : null;
    }

};

function switchTznrHtml(show) {
    if(show){
        $('#switchTznr').html('<i class="fa fa-eye" aria-hidden="true"></i> 显示特征');
    }
    else {
        $('#switchTznr').html('<i class="fa fa-eye-slash" aria-hidden="true"></i> 隐藏特征');
    }
}

$('#switchTznr').click(function () {
    let me = colSettingObj;
    let cur = $(this).text();
    if(cur.includes('显示特征')){
        switchTznrHtml(false);
        me.setVisible('itemCharacterText', true);
        me.updateColSetting(true);
    }
    else {
        switchTznrHtml(true);
        me.setVisible('itemCharacterText', false);
        me.updateColSetting(true);
    }
    let mainSheet = projectObj.mainSpread.getActiveSheet();
    mainSheet.showRow(mainSheet.getActiveRowIndex(), GC.Spread.Sheets.VerticalPosition.center);
});

$('#poj-set').on('shown.bs.modal', function (e) {
    if (!colSettingObj.settingSpread) {
        colSettingObj.initSettingSpread();
        if(projectReadOnly){
            sheetCommonObj.disableSpread(colSettingObj.settingSpread);
        }
    }
    if($('#tab_display_setting').hasClass('active')){
        let sheet = colSettingObj.settingSpread.getActiveSheet();
        SheetDataHelper.massOperationSheet(sheet, function () {
            for(let row = 0; row < sheet.getRowCount(); row++){
                let orgData = projectObj.project.projSetting.main_tree_col.cols[row].visible;
                sheet.setValue(row, 0, orgData);
            }
        });
    }
    // 清单限价
    $('#max-price-rate') && $('#max-price-rate').val(projectObj.project.property.maxPriceRate || 0);
    $('#min-price-rate') && $('#min-price-rate').val(projectObj.project.property.minPriceRate || 0);
});

$('#poj-set').on('hidden.bs.modal', function (e) {
    if (colSettingObj.settingSpread) {
        //恢复
        let sheet = colSettingObj.settingSpread.getActiveSheet();
        SheetDataHelper.massOperationSheet(sheet, function () {
            for(let row = 0; row < sheet.getRowCount(); row++){
                let orgData = projectObj.project.projSetting.main_tree_col.cols[row].visible;
                sheet.setValue(row, 0, orgData);
            }
        });
    }
});

$('#tab_display_setting').on('shown.bs.tab', function () {
    sheetCommonObj.refreshWorkbookDelDefer(colSettingObj.settingSpread, 100);
});
